package edu.mermet.tp8.actions;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JInternalFrame;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameListener;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.ecouteur.EcouteurAuto;
import edu.mermet.tp8.ecouteur.EcouteurAfficher;

public class ActionAfficherConversion extends AbstractAction {
	public Application a;
	
    public ActionAfficherConversion(Application a) {
        super("Conversion Celsius/Farenheit");
        this.a = a;
        putValue(Action.ACCELERATOR_KEY,KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_DOWN_MASK));
        putValue(Action.MNEMONIC_KEY,KeyEvent.VK_C);
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
    	
    	try {
			
    		Properties p = System.getProperties();        	
        	String name = p.getProperty("user.name");
        	
        	String adresse = "src/main/java/edu/mermet/tp8/donnesUtilisateur/"+ name +".properties";
        	
        	InputStream input = new FileInputStream(adresse);
    		
			Properties prop = new Properties();

            prop.load(input);
            
            InternalFrameListener[] listener = a.getFenetreConversions().getInternalFrameListeners();
        	for(int i = 0; i < listener.length; i++) {
        		a.getFenetreConversions().removeInternalFrameListener(listener[i]);
        	}
            
            if(prop.getProperty("conv").contains("Auto")) {
            	if(Double.parseDouble(prop.getProperty("competence")) < 4) {
            		a.getFenetreConversions().setVisible(false); 
                    a.enableConversion(false);
            	}else {
            		if(Double.parseDouble(prop.getProperty("competence")) < 16 && Double.parseDouble(prop.getProperty("competence")) >= 4) {
            			double n = Double.parseDouble(prop.getProperty("competence")) + 0.4;
        				prop.setProperty("competence", n+"");
        				
        				if(prop.getProperty("sug"+11).equals("cach")) {
        					for(int i = 11; i <= 12; i++) {
        						prop.setProperty("sug"+i, "yes");            		
        	            	}
        				}
        				
        				OutputStream output = new FileOutputStream(adresse);
        	            prop.store(output, null);
            		}
            		a.getFenetreConversions().setVisible(true);
                	a.getFenetreConversions().addInternalFrameListener(new EcouteurAuto(a.getFenetreConversions(), this));    	
                    a.enableConversion(false);
            	}            	
            }else if (prop.getProperty("conv").contains("Afficher")) {
            	a.getFenetreConversions().setVisible(true);
            	a.getFenetreConversions().addInternalFrameListener(new EcouteurAfficher(a.getFenetreConversions(), this));
                a.enableConversion(false);
            }else {
            	a.getFenetreConversions().setVisible(false); 
                a.enableConversion(false);
            }
            
		}catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
