package edu.mermet.tp8.actions;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameListener;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.ecouteur.EcouteurAfficher;
import edu.mermet.tp8.ecouteur.EcouteurAuto;

public class ActionAfficherDiaporama extends AbstractAction {
	private Application a;
	
    public ActionAfficherDiaporama(Application a) {
        super("Diaporama");
        this.a = a;
        putValue(Action.ACCELERATOR_KEY,KeyStroke.getKeyStroke(KeyEvent.VK_D, InputEvent.CTRL_DOWN_MASK));
        putValue(Action.MNEMONIC_KEY,KeyEvent.VK_D);
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
    	try {
			
    		Properties p = System.getProperties();        	
        	String name = p.getProperty("user.name");
        	
        	String adresse = "src/main/java/edu/mermet/tp8/donnesUtilisateur/"+ name +".properties";
        	
        	InputStream input = new FileInputStream(adresse);
    		
			Properties prop = new Properties();

            prop.load(input);
            
            InternalFrameListener[] listener = a.getFenetreDiapo().getInternalFrameListeners();
        	for(int i = 0; i < listener.length; i++) {
        		a.getFenetreDiapo().removeInternalFrameListener(listener[i]);
        	}
            
            
            if(prop.getProperty("diapo").contains("Auto")) {
            	if(Double.parseDouble(prop.getProperty("competence")) < 2) {
            		a.getFenetreDiapo().setVisible(false);            	 
                    a.enableDiaporama(false);
            	}else {
            		if(Double.parseDouble(prop.getProperty("competence")) < 8 && Double.parseDouble(prop.getProperty("competence")) >= 2) {
            			double n = Double.parseDouble(prop.getProperty("competence")) + 0.2;
        				prop.setProperty("competence", n+"");
        				
        				if(prop.getProperty("sug"+9).equals("cach")) {
        					for(int i = 9; i <= 10; i++) {
        						prop.setProperty("sug"+i, "yes");            		
        	            	}
        				}
        				
        				OutputStream output = new FileOutputStream(adresse);
        	            prop.store(output, null);
            		}
            		a.getFenetreDiapo().setVisible(true);
                	a.getFenetreDiapo().addInternalFrameListener(new EcouteurAuto(a.getFenetreDiapo(), this));           	
                    a.enableDiaporama(false);
            	}
            	
            }else if (prop.getProperty("diapo").contains("Afficher")) {
            	a.getFenetreDiapo().setVisible(true);
            	a.getFenetreDiapo().addInternalFrameListener(new EcouteurAfficher(a.getFenetreDiapo(), this));
                a.enableDiaporama(false);
            }else {
            	a.getFenetreDiapo().setVisible(false);            	 
                a.enableDiaporama(false);
            }
            
		}catch (IOException ex) {
            ex.printStackTrace();
        }
    }

}
